src/Entity/Formations.php
<?php

namespace App\Entity;

use App\Repository\FormationsRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Vich\UploaderBundle\Mapping\Annotation as Vich;
use Symfony\Component\HttpFoundation\File\File;

#[ORM\Entity(repositoryClass: FormationsRepository::class)]
#[Vich\Uploadable]
class Formations
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 255)]
    private $title;

    #[ORM\Column(type: 'string', length: 255)]
    private $description;

    #[ORM\Column(type: 'text')]
    private $content;

    #[ORM\ManyToOne(targetEntity: User::class, inversedBy: 'formations')]
    #[ORM\JoinColumn(nullable: false)]
    private $author;

    #[ORM\Column(type: 'boolean')]
    private $is_published;

    #[ORM\Column(type: 'datetime')]
    private $creation_date;

    #[ORM\Column(type: 'datetime', nullable: true)]
    private $edition_date;

    #[ORM\Column(type: 'string', length: 255)]
    private $file;
    
    #[Vich\UploadableField(mapping: "formations_images", fileNameProperty: "file")]
    private $imageFile;

    #[ORM\Column(type: 'string', length: 255)]
    private $slug;

    #[ORM\ManyToOne(targetEntity: Tags::class, inversedBy: 'formations')]
    private $tag;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $difficulty;

    #[ORM\ManyToOne(targetEntity: Categories::class, inversedBy: 'formations')]
    private $category;
    
    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getAuthor(): ?User
    {
        return $this->author;
    }

    public function setAuthor(?User $author): self
    {
        $this->author = $author;

        return $this;
    }

    public function getIsPublished(): ?bool
    {
        return $this->is_published;
    }

    public function setIsPublished(bool $is_published): self
    {
        $this->is_published = $is_published;

        return $this;
    }

    public function getCreationDate(): ?\DateTimeInterface
    {
        return $this->creation_date;
    }

    public function setCreationDate(\DateTimeInterface $creation_date): self
    {
        $this->creation_date = $creation_date;

        return $this;
    }

    public function getEditionDate(): ?\DateTimeInterface
    {
        return $this->edition_date;
    }

    public function setEditionDate(?\DateTimeInterface $edition_date): self
    {
        $this->edition_date = $edition_date;

        return $this;
    }

    public function getFile(): ?string
    {
        return $this->file;
    }

    public function setFile(string $file): self
    {
        $this->file = $file;

        return $this;
    }

    public function setImageFile(?File $file = null)
    {
        $this->imageFile = $file;

        if ($file) {
            $this->creation_date = new \DateTime('now');
        }
    }

    public function getImageFile()
    {
         return $this->imageFile;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getTag(): ?Tags
    {
        return $this->tag;
    }

    public function setTag(?Tags $tag): self
    {
        $this->tag = $tag;

        return $this;
    }

    public function getDifficulty(): ?string
    {
        return $this->difficulty;
    }

    public function setDifficulty(?string $difficulty): self
    {
        $this->difficulty = $difficulty;

        return $this;
    }

    public function getCategory(): ?Categories
    {
        return $this->category;
    }

    public function setCategory(?Categories $category): self
    {
        $this->category = $category;

        return $this;
    }
}

src/Controller/FormationsController.php
<?php

namespace App\Controller;

use App\Entity\Formations;
use App\Repository\CategoriesRepository;
use App\Repository\FormationsRepository;
use App\Repository\TagsRepository;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class FormationsController extends AbstractController
{
    #[Route('/formations', name: 'app_formations')]
    public function index(CategoriesRepository $categoriesRepository,
                          FormationsRepository $formationsRepository,
                          TagsRepository $tagsRepository,
                          PaginatorInterface $paginator,
                          Request $request): Response
    {
        $data = $formationsRepository->findAll();
        $formations = $paginator->paginate(
            $data,
            $request->query->getInt('page', 1),
            10
        );

        return $this->render('formations/index.html.twig', [
            'categories' => $categoriesRepository->findAll(),
            'tag' => $tagsRepository->findAll(),
            'formations' => $formations,
        ]);
    }
    #[Route("/formation/{slug}", name: 'app_formation')]
    public function getFormation(Formations $formation)
    {
        return $this->render('formations/getFormation.html.twig', [
            'formation' => $formation,
        ]);
    }
}

templates/formations/getFormation.html.twig
{% extends 'base.html.twig' %}

{% block title %}EcoIT - {{ formation.title }}{% endblock %}

{% block body %}
<section id="formation-header" class="d-flex align-items-center">
	<div class="container">
		<div class="row">
			<div class="col-lg-12 d-flex flex-column text-white" data-aos="fade-up" data-aos-delay="200">
				    <h1>{{ formation.title }}</h1>
				    <h3>Difficulté: {{ formation.difficulty }}/5</h3>
			</div>
		</div>
	</div>
</section>
<section>
    
</section>
{% endblock %}

templates/formations/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}EcoIT - Formations!{% endblock %}

{% block body %}
<section id="hero" class="d-flex align-items-center">
	<div class="container">
		<div class="row">
			<div class="col-lg-6 d-flex flex-column justify-content-center pt-4 pt-lg-0 order-2 order-lg-1" data-aos="fade-up" data-aos-delay="200">
				<h1>Nos formations</h1>
				<h2>Développez vos connaissances grâce à nos cours en ligne 100% a votre rythme</h2>
				<div class="d-flex justify-content-center justify-content-lg-start">
					<a href="#about" class="btn-get-started scrollto">Commencer !</a>
					<a href="https://www.youtube.com" class="glightbox btn-watch-video"><i class="fas fa-play-circle"></i><span>Présentation</span></a>
				</div>
			</div>
			<div class="col-lg-6 order-1 order-lg-2 hero-img" data-aos="zoom-in" data-aos-delay="200">
				<img src="{{ asset('/images/why-us.png') }}" class="img-fluid animated" alt="">
			</div>
		</div>
	</div>
</section><!-- End Hero -->
<section id="team" class="team section-bg">
	<div id="formations" class="container" data-aos="fade-up">
		<div class="section-title">
			<h2>Formations</h2>
			{% if is_granted('IS_AUTHENTICATED_REMEMBERED') %}
				<h3>Bienvenue dans la liste des formations vous pouvez filtrer selon vos besoins.</h3>
			{% else %}
				<h3>Pour acceder aux formations veuillez vous <a href="/login">connecter</h3>
			{% endif %}
		</div>
		<div class="d-flex">
			<select>
				<option value="">Choisissez</option>
				{% for category in categories %}
					<option value="{{ category.id }}">{{ category.name }}</option>
				{% endfor %}
			</select>
		</div>
		<div class="row">
		{% for formation in formations %}
			<a href="{% if is_granted('IS_AUTHENTICATED_REMEMBERED') %}{{ path('app_formation', {'slug': formation.slug}) }}{% else %} {{ path('app_login') }}{% endif %}" class="col-lg-12 mt-4">
				<div class="member d-flex align-items-start w-100" data-aos="zoom-in" data-aos-delay="100">
					<div class="thumb picture bg-cover card-img-start">
						<img class="img-thumbnail" src="{{ vich_uploader_asset(formation, 'imageFile') }}"/>
					</div>
					<div class="member-info w-100">
						<p>{{ formation.category }} - {{ formation.tag }}</p>
						<h4>{{ formation.title }}</h4>
						<p class="my-2">{{ formation.difficulty }}</p>
						<p>{{ formation.description }}</p>
						<div class="d-flex justify-content-end">
							<div>
								{% if formation.editionDate %}
									<p>Mis à jour le: {{ formation.editionDate|date('d/m/Y') }}</p>
								{% else %}
									<p>Crée le: {{ formation.creationDate|date('d/m/Y') }}</p>
								{% endif %}
							</div>
						</div>
					</div>
				</div>
			</a>
		{% endfor %}
	</div>
	<div class="d-flex justify-content-center mt-md-2">
		{% do formations.setPageRange(2) %}
		{{ knp_pagination_render(formations, 'base/pagination.html.twig') }}
	</div>
</section>
{% endblock %}